//+------------------------------------------------------------------+
//|                                           FX Sniper's T3 CCI.mq4 |
//|                                                        FX Sniper |
//+------------------------------------------------------------------+
//|                                          Modified by AMB (cattus)|
//|                                                          Jul/2008|
//+------------------------------------------------------------------+
#property copyright "FX Sniper:  T3-CCI :-)"
#property link      "http://dunno.com  :-)/"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  Yellow
#property indicator_color2  Blue
#property indicator_color3  White
#property indicator_color4  DimGray
#property indicator_color5  DarkSlateGray
#property indicator_color6  Black
#property indicator_color7  Lime
#property indicator_width7  1
#property indicator_color8  Red
#property indicator_width8  1

/* Prices
PRICE_CLOSE 0 Close price. 
PRICE_OPEN 1 Open price. 
PRICE_HIGH 2 High price. 
PRICE_LOW 3 Low price. 
PRICE_MEDIAN 4 Median price, (high+low)/2. 
PRICE_TYPICAL 5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
*/

/*
MODE_SMA 0 Simple moving average, 
MODE_EMA 1 Exponential moving average, 
MODE_SMMA 2 Smoothed moving average, 
MODE_LWMA 3 Linear weighted moving average. 
*/

//----
extern bool ShowSignals = true;
extern string note1 = "----- PRICE -----";
extern string note2 = "0:Close,1:Open,2:High,3:Low";
extern string note3 = "4:Median,5:Typical,6:Weighted";
extern string note4 = "----- MOVING AVERAGE -----";
extern string note5 = "0:SMA,1:EMA,2:Smoothed,3:LWMA";
extern int CCI_Price = 6;
extern int CCI_Period = 3;
extern int T3_Period = 6;
extern double b = 0.5;
extern string note6 = "----- AVERAGE 1 -----";
extern int PeriodAvg1 = 2;
extern int MAMethod1 = 0;
extern string note7 = "----- AVERAGE 2 -----";
extern int PeriodAvg2 = 3;
extern int MAMethod2 = 2;

//----
double e1, e2, e3, e4, e5, e6;
double c1, c2, c3, c4;
double n, w1, w2, b2, b3;
double cci[];
double Avg[];
double cciHupSt[];
double cciHupWe[];
double cciHdnSt[];
double cciHdnWe[];
double Up[];
double Dn[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators setting
    SetIndexBuffer(0, cci);
    SetIndexStyle(0, DRAW_LINE,0,2);

    SetIndexBuffer(1, Avg);
    SetIndexStyle(1, DRAW_LINE,0,2);

    SetIndexBuffer(2, cciHupSt);
    SetIndexStyle(2, DRAW_HISTOGRAM,0,3);
    
    SetIndexBuffer(3, cciHupWe);
    SetIndexStyle(3, DRAW_HISTOGRAM,0,3); 

    SetIndexBuffer(4, cciHdnSt);
    SetIndexStyle(4, DRAW_HISTOGRAM,0,3);
    
    SetIndexBuffer(5, cciHdnWe);
    SetIndexStyle(5, DRAW_HISTOGRAM,0,3); 

    SetIndexBuffer(6, Up);
    SetIndexStyle(6, DRAW_ARROW);
    SetIndexArrow(6, 233);

    SetIndexBuffer(7, Dn);
    SetIndexStyle(7, DRAW_ARROW);
    SetIndexArrow(7, 234);

//----        
    IndicatorShortName("FXST3CCI(" + CCI_Price + ", " + CCI_Period + ", " + T3_Period + ", " + b + ")");
    SetIndexLabel(0, "FXST3CCI");     

//---- variable reset
    b2 = b*b;
    b3 = b2*b;
    c1 = -b3;
    c2 = (3*(b2 + b3));
    c3 = -3*(2*b2 + b + b3);
    c4 = (1 + 3*b + b3 + 3*b2);
    n = T3_Period;

//----
    if(n < 1) 
        n = 1;
    n = 1 + 0.5*(n - 1);
    w1 = 2 / (n + 1);
    w2 = 1 - w1;    

//----
    return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;  


//---- indicator calculation
   for(int i=Bars-1; i>=0; i--)
      {   
       cci[i] = iCCI(NULL, 0, CCI_Period, CCI_Price, i);
       e1 = w1*cci[i] + w2*e1;
       e2 = w1*e1 + w2*e2;
       e3 = w1*e2 + w2*e3;
       e4 = w1*e3 + w2*e4;
       e5 = w1*e4 + w2*e5;
       e6 = w1*e5 + w2*e6;    

       //---- Linea
       cci[i] = c1*e6 + c2*e5 + c3*e4 + c4*e3;  
       
      //---- Histograma
       if(cci[i]>=0 && cci[i]>cci[i+1])  cciHupSt[i]=cci[i];
       if(cci[i]>=0 && cci[i]<=cci[i+1]) cciHupWe[i]=cci[i];
       
       if(cci[i]<0 && cci[i]>=cci[i+1])  cciHdnSt[i]=cci[i];
       if(cci[i]<0 && cci[i]<cci[i+1])   cciHdnWe[i]=cci[i];
      }

//---- Lnea Promedio
   for(i=Bars-1; i>=0; i--)
      {   
       Avg[i] = iMAOnArray(cci,0,PeriodAvg1,0,MAMethod1,i);
      }

//---- Seales
   for(i=Bars-1; i>=0; i--)
      {   
       if((cci[i+1]<=Avg[i+1]) && (cci[i]>Avg[i]) && (cci[i-1]>Avg[i-1]))  Up[i]=0;   
       if((cci[i+1]>=Avg[i+1]) && (cci[i]<Avg[i]) && (cci[i-1]<Avg[i-1]))  Dn[i]=0;  
      }   
//----
   return(0);
  }
//+------------------------------------------------------------------+